diff -ruN ../nakedmudv3.7/src/Makefile src/Makefile
--- ../nakedmudv3.7/src/Makefile	2008-12-06 00:20:20.000000000 -0500
+++ src/Makefile	2009-03-02 12:51:25.000000000 -0500
@@ -39,7 +39,7 @@
 
 # each module will add to this from its module.mk file
 SRC     := gameloop.c mud.c utils.c interpret.c handler.c inform.c \
-	   action.c mccp.c save.c socket.c io.c strings.c event.c \
+	   action.c save.c socket.c io.c strings.c event.c \
 	   \
 	   races.c \
 	   \
@@ -50,7 +50,7 @@
 	   \
 	   list.c property_table.c hashtable.c map.c storage.c set.c \
 	   buffer.c bitvector.c numbers.c prototype.c hooks.c parse.c \
-	   near_map.c command.c
+	   near_map.c command.c filebuf.c
 
 
 
@@ -68,7 +68,7 @@
 ################################################################################
 
 # when performing a backup, these are the directories we'd like to include
-BACKUP_DIRS := src lib doc
+BACKUP_DIRS := src lib doc html
 
 # the name of the backup file we will be creating (time-stamping added)
 BACKUP_FILE := backup/$(PROJECT)-$(shell date +%Y-%m-%d-%Hh%Mm).tar.tgz
diff -ruN ../nakedmudv3.7/src/SConstruct src/SConstruct
--- ../nakedmudv3.7/src/SConstruct	2008-05-31 00:17:59.000000000 -0400
+++ src/SConstruct	2009-02-17 01:57:31.000000000 -0500
@@ -62,13 +62,17 @@
 modules = ['dyn_vars', 'set_val', 'olc2', 'editor', 'items', 'scripts']
 
 # Optional modules
-modules += ['time', 'socials', 'alias', 'help']
+modules += ['time', 'socials', 'alias', 'help2']
 
 # Compiler flags
 nakedmud.Append(CCFLAGS=['-Wall', '-g', '-ggdb', '-O2'])
 
 # Required libraries
-nakedmud.Append(LIBS=['z', 'pthread', 'crypt'])
+nakedmud.Append(LIBS=['z', 'pthread'])
+
+# non-darwin OSes need to include crypt
+if platform != 'darwin':
+   nakedmud.Append(LIBS=['crypt'])
 
 # The big list of source files.
 nakedmud['NAKEDMUD_SOURCES'] = glob('*.c')
diff -ruN ../nakedmudv3.7/src/account.c src/account.c
--- ../nakedmudv3.7/src/account.c	2008-05-31 00:17:59.000000000 -0400
+++ src/account.c	2009-03-02 01:00:31.000000000 -0500
@@ -28,7 +28,7 @@
   char          *name; // the name of our account
   char      *password; // our password to log on
   LIST    *characters; // our list of character names
-  HASHTABLE      *aux; // auxiliary data we have installed
+  AUX_TABLE      *aux; // auxiliary data we have installed
 };
 
 
@@ -123,7 +123,7 @@
 }
 
 void *accountGetAuxiliaryData(ACCOUNT_DATA *account, const char *data) {
-  return hashGet(account->aux, data);
+  return auxiliaryGet(account->aux, data);
 }
 
 void accountSetPassword(ACCOUNT_DATA *account, const char *password) {
diff -ruN ../nakedmudv3.7/src/action.c src/action.c
--- ../nakedmudv3.7/src/action.c	2008-05-31 00:17:59.000000000 -0400
+++ src/action.c	2009-03-02 01:00:31.000000000 -0500
@@ -53,28 +53,6 @@
 
 
 //*****************************************************************************
-// A small test for delayed actions ... proof of concept
-//*****************************************************************************
-void do_dsay(CHAR_DATA *ch, void *data, bitvector_t where, char *arg) {
-  communicate(ch, arg, COMM_LOCAL);
-}
-
-void dsay_interrupt(CHAR_DATA *ch, void *data, bitvector_t where, char *arg) {
-  send_to_char(ch, "Your delayed say was interrupted.\r\n");
-}
-
-COMMAND(cmd_dsay) {
-  if(!*arg)
-    send_to_char(ch, "What did you want to delay-say?\r\n");
-  else {
-    send_to_char(ch, "You start a delayed say.\r\n");
-    start_action(ch, 3 SECOND, 1, do_dsay, dsay_interrupt, NULL, arg);
-  }
-}
-
-
-
-//*****************************************************************************
 // single action handling
 //*****************************************************************************
 ACTION_DATA *newAction(int delay, 	
@@ -128,9 +106,6 @@
   // use the standard pointer hasher and comparator
   actors = newMap(NULL, NULL);
 
-  // add in our example delayed action
-  add_cmd("dsay", NULL, cmd_dsay, "admin", FALSE);
-
   // make sure the character does not continue actions after being extracted
   hookAdd("char_from_game", stop_actions_hook);
 }
@@ -151,8 +126,7 @@
       action_found = TRUE;
       break;
     }
-  }
-  deleteListIterator(act_i);
+  } deleteListIterator(act_i);
 
   return action_found;
 }
@@ -176,14 +150,21 @@
 	listRemove(actions, action);
 	deleteAction(action);
       }
-    }
-    deleteListIterator(act_i);
+    } deleteListIterator(act_i);
   }
 
   // if all of the actions are gone, delete the list
   if(listSize(actions) == 0) {
+    /*
+     * Nope! We can't do this. If we interrupt an action midway through
+     * processing actions and the list gets deleted, the iterator over it will
+     * blow up when we try to delete it. Instead, deletion will now occur when
+     * we try to process actions and realize there is nothing in the list to
+     * process.
+     *
     mapRemove(actors, ch);
     deleteList(actions);
+    */
   }
 }
 
@@ -210,7 +191,7 @@
 }
 
 void pulse_actions(int time) {
-  MAP_ITERATOR   *ch_i = newMapIterator(actors);
+  MAP_ITERATOR    *ch_i = newMapIterator(actors);
   ACTION_DATA   *action = NULL;
   LIST_ITERATOR  *act_i = NULL;
   LIST         *actions = NULL;
@@ -220,8 +201,13 @@
   ITERATE_MAP(map_actor, actions, ch_i) {
     actions = mapIteratorCurrentVal(ch_i);
 
+    // weird, we shouldn't be in here
+    if(listSize(actions) == 0) {
+      mapRemove(actors, map_actor);
+      deleteList(actions);
+    }
     // if we have actions, then go through 'em all
-    if(listSize(actions) > 0) {
+    else {
       // eek... small problem. The key for maps is constant, but we need
       // a non-constant character to send to run_action. Let's get the char's
       // UID, and re-look him up in the player table
diff -ruN ../nakedmudv3.7/src/alias/alias.c src/alias/alias.c
--- ../nakedmudv3.7/src/alias/alias.c	2008-05-31 00:17:59.000000000 -0400
+++ src/alias/alias.c	2009-03-02 01:00:31.000000000 -0500
@@ -14,12 +14,21 @@
 #include "../character.h"
 #include "../socket.h"
 #include "../action.h"
+#include "../hooks.h"
 
 #include "alias.h"
 
 
 
 //*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "../scripts/scripts.h"
+#include "../scripts/pychar.h"
+
+
+
+//*****************************************************************************
 // auxiliary data
 //*****************************************************************************
 typedef struct alias_aux_data {
@@ -119,6 +128,13 @@
 //*****************************************************************************
 // functions for interacting with character aliases
 //*****************************************************************************
+LIST *charGetAliases(CHAR_DATA *ch) {
+  ALIAS_AUX_DATA *data = charGetAuxiliaryData(ch, "alias_aux_data");
+  if(data->aliases == NULL)
+    return newList();
+  return hashCollect(data->aliases);
+}
+
 const char *charGetAlias(CHAR_DATA *ch, const char *alias) {
   ALIAS_AUX_DATA *data = charGetAuxiliaryData(ch, "alias_aux_data");
   if(data->aliases == NULL)
@@ -126,6 +142,15 @@
   return hashGet(data->aliases, alias);
 }
 
+void charClearAliases(CHAR_DATA *ch) {
+  LIST *aliases = charGetAliases(ch);
+  LIST_ITERATOR *alias_i = newListIterator(aliases);
+  const char      *alias = NULL;
+  ITERATE_LIST(alias, alias_i) {
+    charSetAlias(ch, alias, NULL);
+  } deleteListIterator(alias_i);
+  deleteListWith(aliases, free);
+}
 
 void charSetAlias(CHAR_DATA *ch, const char *alias, const char *cmd){
   ALIAS_AUX_DATA *data = charGetAuxiliaryData(ch, "alias_aux_data");
@@ -135,11 +160,14 @@
 
   // pull out the last one
   char *oldcmd = hashRemove(data->aliases, alias);
+
   if(oldcmd != NULL)
     free(oldcmd);
+
   // put in the new one if it exists
-  if(cmd && *cmd)
+  if(cmd && *cmd) {
     hashPut(data->aliases, alias, strdup(cmd));
+  }
 }
 
 int charGetAliasesQueued(CHAR_DATA *ch) {
@@ -158,7 +186,7 @@
   BUFFER *cmd = newBuffer(SMALL_BUFFER);
   func_depth++;
 
-  BUFFER *filled_alias = newBuffer(MAX_BUFFER);
+  BUFFER *filled_alias = newBuffer(SMALL_BUFFER);
   bufferCat(filled_alias, alias);
   // now, replace all of our parameters 
   int i;
@@ -238,13 +266,15 @@
     if(data->aliases == NULL || hashSize(data->aliases) == 0)
       send_to_char(ch, "  none\r\n");
     else {
-      HASH_ITERATOR *alias_i = newHashIterator(data->aliases);
-      const char      *alias = NULL;
-      const char        *cmd = NULL;
-
-      ITERATE_HASH(alias, cmd, alias_i)
-	send_to_char(ch, "  %-20s %s\r\n", alias, cmd);
-      deleteHashIterator(alias_i);
+      LIST             *keys = hashCollect(data->aliases);
+      listSortWith(keys, strcasecmp);
+      LIST_ITERATOR   *key_i = newListIterator(keys);
+      const char        *key = NULL;
+
+      ITERATE_LIST(key, key_i) {
+	send_to_char(ch, "  %-20s %s\r\n", key, (char *)hashGet(data->aliases, key));
+      } deleteListIterator(key_i);
+      deleteListWith(keys, free);
     }
   }
   else {
@@ -258,7 +288,6 @@
 	send_to_char(ch, "You do not have such an alias.\r\n");
       else {
 	charSetAlias(ch, alias, arg);
-	send_to_char(ch, "Alias deleted.\r\n");
       }
     }
 
@@ -273,6 +302,68 @@
 
 
 //*****************************************************************************
+// Python extensions
+//*****************************************************************************
+PyObject *PyChar_GetAlias(PyObject *self, PyObject *args) {
+  char   *alias = NULL;
+  CHAR_DATA *ch = NULL;
+  if(!PyArg_ParseTuple(args, "s", &alias)) {
+    PyErr_Format(PyExc_TypeError, "aliases must be string names.");
+    return NULL;
+  }
+
+  if( (ch = PyChar_AsChar(self)) == NULL) {
+    PyErr_Format(PyExc_TypeError, "Character %d does not exist.",
+		 PyChar_AsUid(self));
+    return NULL;
+  }
+
+  return Py_BuildValue("z", charGetAlias(ch, alias));
+}
+
+PyObject *PyChar_SetAlias(PyObject *self, PyObject *args) {
+  char     *cmd = NULL;
+  char   *alias = NULL;
+  CHAR_DATA *ch = NULL;
+  if(!PyArg_ParseTuple(args, "sz", &alias, &cmd)) {
+    PyErr_Format(PyExc_TypeError, "aliases and commands must be string names.");
+    return NULL;
+  }
+
+  if( (ch = PyChar_AsChar(self)) == NULL) {
+    PyErr_Format(PyExc_TypeError, "Character %d does not exist.",
+		 PyChar_AsUid(self));
+    return NULL;
+  }
+
+  charSetAlias(ch, alias, cmd);
+  return Py_BuildValue("i", 1);
+}
+
+PyObject *PyChar_GetAliases(PyObject *self, void *closure) {
+  CHAR_DATA *ch = NULL;
+  if((ch = PyChar_AsChar(self)) == NULL) {
+    PyErr_Format(PyExc_TypeError, "Character %d does not exist.",
+		 PyChar_AsUid(self));
+    return NULL;
+  }
+
+  PyObject       *pylist = PyList_New(0);
+  LIST             *list = charGetAliases(ch);
+  LIST_ITERATOR *alias_i = newListIterator(list);
+  const char      *alias = NULL;
+  ITERATE_LIST(alias, alias_i) {
+    PyObject *str = Py_BuildValue("s", alias);
+    PyList_Append(pylist, str);
+    Py_DECREF(str);
+  } deleteListIterator(alias_i);
+  deleteListWith(list, free);
+  return pylist;
+}
+
+
+
+//*****************************************************************************
 // implementation of alias.h
 //*****************************************************************************
 void init_aliases() {
@@ -285,6 +376,11 @@
 
   // allow people to view their aliases
   add_cmd("alias", NULL, cmd_alias, "player", TRUE);
+
+  // Python extensions
+  PyChar_addMethod("get_alias", PyChar_GetAlias,   METH_VARARGS, NULL);
+  PyChar_addMethod("set_alias", PyChar_SetAlias,   METH_VARARGS, NULL);
+  PyChar_addGetSetter("aliases",PyChar_GetAliases, NULL,         NULL);
 }
 
 
diff -ruN ../nakedmudv3.7/src/alias/alias.h src/alias/alias.h
--- ../nakedmudv3.7/src/alias/alias.h	2008-05-31 00:17:59.000000000 -0400
+++ src/alias/alias.h	2009-03-02 01:00:31.000000000 -0500
@@ -29,4 +29,12 @@
 int charGetAliasesQueued(CHAR_DATA *ch);
 void charSetAliasesQueued(CHAR_DATA *ch, int amnt);
 
+//
+// access aliases the character has. Returned lists and contents must be
+// deleted after used.
+LIST     *charGetAliases(CHAR_DATA *ch);
+const char *charGetAlias(CHAR_DATA *ch, const char *alias);
+void    charClearAliases(CHAR_DATA *ch);
+void        charSetAlias(CHAR_DATA *ch, const char *alias, const char *cmd);
+
 #endif // __ALIAS_H
diff -ruN ../nakedmudv3.7/src/auxiliary.c src/auxiliary.c
--- ../nakedmudv3.7/src/auxiliary.c	2008-05-31 00:17:59.000000000 -0400
+++ src/auxiliary.c	2009-03-02 01:00:31.000000000 -0500
@@ -18,6 +18,7 @@
 #include "auxiliary.h"
 
 
+
 //*****************************************************************************
 //
 // local variables, datastructures, and functions
@@ -97,9 +98,9 @@
 }
 
 
-HASHTABLE *
+AUX_TABLE *
 newAuxiliaryData(bitvector_t aux_type) {
-  HASHTABLE        *data = newHashtable();
+  AUX_TABLE        *data = newHashtable();
   HASH_ITERATOR  *hash_i = newHashIterator(auxiliary_manip_funcs);
   AUXILIARY_FUNCS *funcs = NULL;
   const char       *name = NULL;
@@ -121,7 +122,7 @@
 
 
 void
-auxiliaryEnsureDataComplete(HASHTABLE *data, bitvector_t aux_type) {
+auxiliaryEnsureDataComplete(AUX_TABLE *data, bitvector_t aux_type) {
   HASH_ITERATOR  *hash_i = newHashIterator(auxiliary_manip_funcs);
   AUXILIARY_FUNCS *funcs = NULL;
   const char       *name = NULL;
@@ -142,7 +143,7 @@
 
 
 void
-deleteAuxiliaryData(HASHTABLE *data) {
+deleteAuxiliaryData(AUX_TABLE *data) {
   // go across all of the data in the hashtable, and delete it
   AUXILIARY_FUNCS *funcs  = NULL;
   HASH_ITERATOR   *hash_i = newHashIterator(data);
@@ -158,7 +159,7 @@
 
 
 STORAGE_SET *
-auxiliaryDataStore(HASHTABLE *data) {
+auxiliaryDataStore(AUX_TABLE *data) {
   STORAGE_SET *set = new_storage_set();
   AUXILIARY_FUNCS *funcs  = NULL;
   HASH_ITERATOR   *hash_i = newHashIterator(data);
@@ -174,9 +175,9 @@
 }
 
 
-HASHTABLE *
+AUX_TABLE *
 auxiliaryDataRead(STORAGE_SET *set, bitvector_t aux_type) {
-  HASHTABLE        *data = newHashtable();
+  AUX_TABLE       *data = newHashtable();
   HASH_ITERATOR  *hash_i = newHashIterator(auxiliary_manip_funcs);
   AUXILIARY_FUNCS *funcs = NULL;
   const char       *name = NULL;
@@ -206,7 +207,7 @@
 
 
 void
-auxiliaryDataCopyTo(HASHTABLE *from, HASHTABLE *to) {
+auxiliaryDataCopyTo(AUX_TABLE *from, AUX_TABLE *to) {
   AUXILIARY_FUNCS *funcs = NULL;
   HASH_ITERATOR  *hash_i = NULL;
   void            *entry = NULL;
@@ -232,9 +233,13 @@
 }
 
 
-HASHTABLE *
-auxiliaryDataCopy(HASHTABLE *data) {
-  HASHTABLE *newdata = newHashtableSize(hashSize(data));
+AUX_TABLE *
+auxiliaryDataCopy(AUX_TABLE *data) {
+  AUX_TABLE *newdata = newHashtableSize(hashSize(data));
   auxiliaryDataCopyTo(data, newdata);
   return newdata;
 }
+
+void *auxiliaryGet(AUX_TABLE *table, const char *key) {
+  return hashGet(table, key);
+}
diff -ruN ../nakedmudv3.7/src/auxiliary.h src/auxiliary.h
--- ../nakedmudv3.7/src/auxiliary.h	2008-05-31 00:17:59.000000000 -0400
+++ src/auxiliary.h	2009-03-02 01:10:28.000000000 -0500
@@ -22,6 +22,10 @@
 #define AUXILIARY_TYPE_ACCOUNT   (1 << 5)
 
 
+//
+// how do we store auxiliary data?
+typedef HASHTABLE AUX_TABLE;
+
 
 //
 // A structure containing 6 functions that are needed for storing and saving
@@ -61,7 +65,7 @@
 // create a new set of functions for handling auxiliary data
 //
 AUXILIARY_FUNCS *
-newAuxiliaryFuncs(bitvector_t aux_type, void *new, void *delete, 
+newAuxiliaryFuncs(bitvector_t aux_type, void *newfunc, void *deleter, 
 		  void *copyTo, void *copy, void *store, void *read);
 
 
@@ -116,7 +120,7 @@
 // Create a new hashtable of auxiliary data for the 
 // datatype specified in aux_type 
 //
-HASHTABLE *
+AUX_TABLE *
 newAuxiliaryData(bitvector_t aux_type);
 
 
@@ -125,20 +129,20 @@
 // data is passed into here and we handle it.
 //
 void
-deleteAuxiliaryData(HASHTABLE *data);
+deleteAuxiliaryData(AUX_TABLE *data);
 
 
 //
 // Put all of the auxiliary data into a storage set
 //
 STORAGE_SET *
-auxiliaryDataStore(HASHTABLE *data);
+auxiliaryDataStore(AUX_TABLE *data);
 
 
 //
 // read the auxiliary data for a specified datatype in from the set
 //
-HASHTABLE *
+AUX_TABLE *
 auxiliaryDataRead(STORAGE_SET *set, bitvector_t aux_type);
 
 
@@ -146,14 +150,18 @@
 // Copy the auxiliary data from one hashtable to another
 //
 void
-auxiliaryDataCopyTo(HASHTABLE *from, HASHTABLE *to);
+auxiliaryDataCopyTo(AUX_TABLE *from, AUX_TABLE *to);
 
 
 //
 // Make a copy of the auxiliary data
 //
-HASHTABLE *
-auxiliaryDataCopy(HASHTABLE *data);
+AUX_TABLE *
+auxiliaryDataCopy(AUX_TABLE *data);
 
 
+//
+// return data from the auxiliary table
+void *auxiliaryGet(AUX_TABLE *table, const char *key);
+
 #endif // __AUXILIARY_H
diff -ruN ../nakedmudv3.7/src/bitvector.c src/bitvector.c
--- ../nakedmudv3.7/src/bitvector.c	2008-05-31 00:17:59.000000000 -0400
+++ src/bitvector.c	2009-03-02 01:00:31.000000000 -0500
@@ -93,6 +93,8 @@
   bitvectorAddBit("user_groups", "builder");
   bitvectorAddBit("user_groups", "player");
   bitvectorAddBit("user_groups", "playtester");
+  bitvectorAddBit("user_groups", "wizard");
+  bitvectorAddBit("user_groups", "empty");
 }
 
 void bitvectorAddBit(const char *name, const char *bit) {
diff -ruN ../nakedmudv3.7/src/body.c src/body.c
--- ../nakedmudv3.7/src/body.c	2008-05-31 00:17:59.000000000 -0400
+++ src/body.c	2009-03-02 01:00:31.000000000 -0500
@@ -114,7 +114,7 @@
 char *list_postypes(const BODY_DATA *B, const char *posnames) {
   LIST           *names = parse_keywords(posnames);
   LIST_ITERATOR *name_i = newListIterator(names);
-  BUFFER           *buf = newBuffer(MAX_BUFFER);
+  BUFFER           *buf = newBuffer(100);
   char            *name = NULL;
   char          *retval = NULL;
   int             found = 0;
@@ -465,8 +465,7 @@
 	strcat(buf, ", ");
       strcat(buf, part->name);
     }
-  }
-  deleteListIterator(part_i);
+  } deleteListIterator(part_i);
   return buf;
 }
 
@@ -485,8 +484,7 @@
       part->equipment = NULL;
       found = TRUE;
     }
-  }
-  deleteListIterator(part_i);
+  } deleteListIterator(part_i);
 
   return found;
 }
@@ -496,10 +494,10 @@
   LIST_ITERATOR *part_i = newListIterator(B->parts);
   BODYPART *part = NULL;
 
-  ITERATE_LIST(part, part_i)
+  ITERATE_LIST(part, part_i) {
     if(part->equipment && !listIn(equipment, part->equipment))
       listPut(equipment, part->equipment);
-  deleteListIterator(part_i);
+  } deleteListIterator(part_i);
   return equipment;
 }
 
@@ -513,8 +511,7 @@
       listPut(equipment, part->equipment);
       part->equipment = NULL;
     }
-  }
-  deleteListIterator(part_i);
+  } deleteListIterator(part_i);
   return equipment;
 }
 
diff -ruN ../nakedmudv3.7/src/buffer.c src/buffer.c
--- ../nakedmudv3.7/src/buffer.c	2008-12-06 00:20:20.000000000 -0500
+++ src/buffer.c	2009-03-02 01:00:31.000000000 -0500
@@ -62,7 +62,7 @@
 }
 
 BUFFER    *bufferCopy  (BUFFER *buf) {
-  BUFFER *newbuf = newBuffer(1);
+  BUFFER *newbuf = newBuffer(bufferLength(buf)+1);
   bufferCopyTo(buf, newbuf);
   return newbuf;
 }
@@ -80,16 +80,11 @@
   return buf->len;
 }
 
-int bprintf(BUFFER *buf, char *fmt, ...) {  
+int vbprintf(BUFFER *buf, const char *fmt, va_list va) {
   static int printsize = 8192;
   char buftmp[printsize];
-  va_list va;
-  int res;
+  int res = vsnprintf(buftmp, printsize, fmt, va);
 
-  va_start(va, fmt);
-  res = vsnprintf(buftmp, printsize, fmt, va);
-  va_end(va);
-    
   if (res >= printsize - 1)
     *buftmp = '\0';
   else
@@ -98,6 +93,14 @@
   return res;
 }
 
+int bprintf(BUFFER *buf, const char *fmt, ...) {  
+  va_list va;
+  va_start(va, fmt);
+  int res = vbprintf(buf, fmt, va);
+  va_end(va);
+  return res;
+}
+
 int bufferReplace(BUFFER *buf, const char *a, const char *b, int all) {
   // first, check if we'll need to expand the size of the buffer
   int a_len = strlen(a), b_len = strlen(b);
@@ -250,7 +253,7 @@
       col = 0;
     }
 
-    char        ch = buf->data[buf_i];
+    char ch = buf->data[buf_i];
     int para_start = -1;
 
     // try to preserve our paragraph structure
@@ -266,7 +269,7 @@
     // no spaces on newlines or ends of lines
     else if(isspace(ch) && (col == 0 || col == max_width-1))
       continue;
-    // we will do our own sentence formatting
+    // we will do our own sentance formatting
     else if(needs_capital && isspace(ch))
       continue;
     // delete multiple spaces
diff -ruN ../nakedmudv3.7/src/buffer.h src/buffer.h
--- ../nakedmudv3.7/src/buffer.h	2008-12-06 00:20:20.000000000 -0500
+++ src/buffer.h	2009-03-02 01:00:31.000000000 -0500
@@ -35,7 +35,10 @@
 int bufferLength(BUFFER *buf);
 
 // do a formatted print onto the buffer (concats it)
-int bprintf(BUFFER *buf, char *fmt, ...) __attribute__ ((format (printf, 2, 3)));
+int bprintf(BUFFER *buf, const char *fmt, ...) __attribute__ ((format (printf, 2, 3)));
+
+// bprintf with a variable list and format supplied
+int vbprintf(BUFFER *buf, const char *fmt, va_list va);
 
 // replace 'a' with 'b'. Return back how many occurences were replaced. If
 // all is FALSE, then only the first occurence is replaced.
diff -ruN ../nakedmudv3.7/src/character.c src/character.c
--- ../nakedmudv3.7/src/character.c	2008-05-31 00:17:59.000000000 -0400
+++ src/character.c	2009-03-02 01:00:31.000000000 -0500
@@ -19,12 +19,6 @@
 #include "storage.h"
 #include "character.h"
 
-
-// mob UIDs (unique IDs) start at a million and go 
-// up by one every time a new NPC is created
-#define START_MOB_UID       1000000
-int next_mob_uid  =   START_MOB_UID;
-
 const char *sex_names[NUM_SEXES] = {
   "male",
   "female",
@@ -92,6 +86,7 @@
 
   // shared data for PCs and NPCs
   int                    uid;
+  time_t                 birth;
 
   BODY_DATA            * body;
   char                 * race;
@@ -107,9 +102,11 @@
   char                 * name;
   int                    sex;
   int                    position;
+  int                    hidden;
+  double                 weight;
 
   LIST                 * inventory;
-  HASHTABLE            * auxiliary_data;
+  AUX_TABLE            * auxiliary_data;
   BITVECTOR            * prfs;
   BITVECTOR            * user_groups;
 
@@ -126,6 +123,7 @@
 
   ch->loadroom      = strdup("");
   ch->uid           = NOBODY;
+  ch->birth         = current_time;
 
   ch->race          = strdup(raceDefault());
   ch->body          = raceCreateBody(ch->race);
@@ -180,7 +178,7 @@
 }
 
 bool charIsNPC( CHAR_DATA *ch) {
-  return (ch->uid >= START_MOB_UID);
+  return (ch->uid >= START_UID);
 }
 
 bool charIsName( CHAR_DATA *ch, const char *name) {
@@ -246,32 +244,44 @@
   return ch->multi_name;
 }
 
-int         charGetSex        ( CHAR_DATA *ch) {
+int charGetSex(CHAR_DATA *ch) {
   return ch->sex;
 }
 
-int         charGetPos        ( CHAR_DATA *ch) {
+int charGetPos(CHAR_DATA *ch) {
   return ch->position;
 }
 
-BODY_DATA   *charGetBody      ( CHAR_DATA *ch) {
+int charGetHidden(const CHAR_DATA *ch) {
+  return ch->hidden;
+}
+
+double charGetWeight(const CHAR_DATA *ch) {
+  return ch->weight;
+}
+
+BODY_DATA *charGetBody(CHAR_DATA *ch) {
   return ch->body;
 }
 
-const char  *charGetRace  ( CHAR_DATA *ch) {
+const char *charGetRace(CHAR_DATA *ch) {
   return ch->race;
 }
 
-int          charGetUID   ( const CHAR_DATA *ch) {
+int charGetUID(const CHAR_DATA *ch) {
   return ch->uid;
 }
 
+time_t       charGetBirth ( const CHAR_DATA *ch) {
+  return ch->birth;
+}
+
 const char *charGetLoadroom (CHAR_DATA *ch) {
   return ch->loadroom;
 }
 
 void *charGetAuxiliaryData(const CHAR_DATA *ch, const char *name) {
-  return hashGet(ch->auxiliary_data, name);
+  return auxiliaryGet(ch->auxiliary_data, name);
 }
 
 OBJ_DATA *charGetFurniture(CHAR_DATA *ch) {
@@ -325,6 +335,14 @@
   ch->position = pos;
 }
 
+void         charSetHidden    ( CHAR_DATA *ch, int amnt) {
+  ch->hidden = amnt;
+}
+
+void charSetWeight(CHAR_DATA *ch, double amnt) {
+  ch->weight = amnt;
+}
+
 void         charSetDesc      ( CHAR_DATA *ch, const char *desc) {
   bufferClear(ch->desc);
   bufferCat(ch->desc, (desc ? desc : ""));
@@ -367,7 +385,7 @@
 //*****************************************************************************
 CHAR_DATA *newMobile() {
   CHAR_DATA *mob = newChar();
-  mob->uid = next_mob_uid++;
+  mob->uid = next_uid();
   return mob;
 };
 
@@ -415,6 +433,8 @@
   bitSet(mob->user_groups, read_string(set, "user_groups"));
   charSetLoadroom(mob,     read_string(set, "loadroom"));
   charSetPos(mob,          read_int   (set, "position"));
+  charSetHidden(mob,       read_int   (set, "hidden"));
+  charSetWeight(mob,       read_double(set, "weight"));
 
   // make sure we always have the default group assigned
   if(!*bitvectorGetBits(mob->user_groups))
@@ -424,6 +444,9 @@
   if(storage_contains(set, "uid"))
     charSetUID(mob,        read_int   (set, "uid"));
 
+  if(storage_contains(set, "birth"))
+    mob->birth = read_long(set, "birth");
+
   deleteAuxiliaryData(mob->auxiliary_data);
   mob->auxiliary_data = auxiliaryDataRead(read_set(set, "auxiliary"), 
 					  AUXILIARY_TYPE_CHAR);
@@ -453,10 +476,13 @@
   store_string(set, "race",       mob->race);
   store_string(set, "prfs",       bitvectorGetBits(mob->prfs));
   store_string(set, "user_groups",bitvectorGetBits(mob->user_groups));
+  store_int   (set, "position",   mob->position);
+  store_int   (set, "hidden",     mob->hidden);
+  store_double(set, "weight",     mob->weight);
+  store_long  (set, "birth",      mob->birth);
 
   // PC-only data
   if(!charIsNPC(mob)) {
-    store_int   (set, "position",   mob->position);
     store_int   (set, "uid",        mob->uid);
     store_string(set, "loadroom",   mob->loadroom);
   }
@@ -477,10 +503,13 @@
   charSetMultiName  (to, charGetMultiName(from));
   charSetSex        (to, charGetSex(from));
   charSetPos        (to, charGetPos(from));
+  charSetHidden     (to, charGetHidden(from));
+  charSetWeight     (to, charGetWeight(from));
   charSetRace       (to, charGetRace(from));
   charSetBody       (to, bodyCopy(charGetBody(from)));
   bitvectorCopyTo   (from->prfs, to->prfs);
   bitvectorCopyTo   (from->prfs, to->prfs);
+  to->birth = from->birth;
 
   auxiliaryDataCopyTo(from->auxiliary_data, to->auxiliary_data);
 }
diff -ruN ../nakedmudv3.7/src/character.h src/character.h
--- ../nakedmudv3.7/src/character.h	2008-05-31 00:17:59.000000000 -0400
+++ src/character.h	2009-03-02 01:00:31.000000000 -0500
@@ -90,6 +90,9 @@
 OBJ_DATA    *charGetFurniture (CHAR_DATA *ch);
 int          charGetPos       (CHAR_DATA *ch);
 int          charGetUID       (const CHAR_DATA *ch);
+time_t       charGetBirth     (const CHAR_DATA *ch);
+int          charGetHidden    (const CHAR_DATA *ch);
+double       charGetWeight    (const CHAR_DATA *ch);
 void        *charGetAuxiliaryData(const CHAR_DATA *ch, const char *name);
 BITVECTOR   *charGetPrfs      (CHAR_DATA *ch);
 BITVECTOR   *charGetUserGroups(CHAR_DATA *ch);
@@ -112,6 +115,8 @@
 void         charSetLoadroom  (CHAR_DATA *ch, const char *key);
 void         charSetFurniture (CHAR_DATA *ch, OBJ_DATA *furniture);
 void         charSetPos       (CHAR_DATA *ch, int pos);
+void         charSetHidden    (CHAR_DATA *ch, int amnt);
+void         charSetWeight    (CHAR_DATA *ch, double amnt);
 
 
 
@@ -141,7 +146,7 @@
 // Positions
 //*****************************************************************************
 #define POS_NONE                (-1)
-#define POS_UNCONSCIOUS            0
+#define POS_UNCONSCIOUS           0
 #define POS_SLEEPING              1
 #define POS_SITTING               2
 #define POS_STANDING              3
diff -ruN ../nakedmudv3.7/src/command.c src/command.c
--- ../nakedmudv3.7/src/command.c	2008-12-06 00:20:20.000000000 -0500
+++ src/command.c	2009-03-02 01:00:31.000000000 -0500
@@ -78,8 +78,9 @@
 
 void cmdCheckCopyTo(CMD_CHK_DATA *from, CMD_CHK_DATA *to) {
   Py_XDECREF(to->pyfunc);
-  Py_XINCREF(from->pyfunc);
-  *to = *from;
+  to->func   = from->func;
+  to->pyfunc = from->pyfunc;
+  Py_XINCREF(to->pyfunc);
 }
 
 
@@ -89,27 +90,40 @@
 //*****************************************************************************
 CMD_DATA *newCmd(const char *name, COMMAND(func), const char *user_group, 
 		 bool interrupts) {
-  CMD_DATA *cmd   = malloc(sizeof(CMD_DATA));
-  cmd->name       = strdupsafe(name);
-  cmd->func       = func;
-  cmd->user_group = strdupsafe(user_group);
-  cmd->interrupts = interrupts;
-  cmd->checks     = newList();
-  cmd->pyfunc     = NULL;
+  CMD_DATA *cmd = calloc(1, sizeof(CMD_DATA));
+  cmd->name     = strdupsafe(name);
+  cmd->checks   = newList();
+  cmdUpdate(cmd, func, user_group, interrupts);
   return cmd;
 }
 
 CMD_DATA *newPyCmd(const char *name, void *pyfunc, const char *user_group, 
 		   bool interrupts) {
-  CMD_DATA *cmd   = malloc(sizeof(CMD_DATA));
+  CMD_DATA *cmd   = calloc(1, sizeof(CMD_DATA));
   cmd->name       = strdupsafe(name);
+  cmd->checks     = newList();
+  cmdPyUpdate(cmd, pyfunc, user_group, interrupts);
+  return cmd;
+}
+
+void cmdUpdate(CMD_DATA *cmd, COMMAND(func), const char *user_group, 
+	       bool interrupts) {
+  if(cmd->pyfunc)     { Py_DECREF(cmd->pyfunc); cmd->pyfunc = NULL; }
+  if(cmd->user_group) free(cmd->user_group);
+  cmd->func       = func;
+  cmd->user_group = strdupsafe(user_group);
+  cmd->interrupts = interrupts;
+}
+
+void cmdPyUpdate(CMD_DATA *cmd, void *pyfunc, const char *user_group,
+		 bool interrupts) {
+  if(cmd->pyfunc)     { Py_DECREF(cmd->pyfunc); cmd->pyfunc = NULL; }
+  if(cmd->user_group) free(cmd->user_group);
   cmd->func       = NULL;
   cmd->user_group = strdupsafe(user_group);
   cmd->interrupts = interrupts;
-  cmd->checks     = newList();
   cmd->pyfunc     = pyfunc;
-  Py_INCREF(cmd->pyfunc);
-  return cmd;
+  Py_XINCREF(cmd->pyfunc);
 }
 
 void deleteCmd(CMD_DATA *cmd) {
@@ -122,10 +136,10 @@
 
 CMD_DATA *cmdCopy(CMD_DATA *cmd) {
   CMD_DATA *newcmd = NULL;
-  if(cmd->func)
-    newcmd = newCmd(cmd->name, cmd->func, cmd->user_group, cmd->interrupts);
-  else
+  if(cmd->pyfunc)
     newcmd = newPyCmd(cmd->name, cmd->pyfunc, cmd->user_group, cmd->interrupts);
+  else
+    newcmd = newCmd(cmd->name, cmd->func, cmd->user_group, cmd->interrupts);
   
   // copy over the checks
   deleteList(newcmd->checks);
@@ -139,9 +153,12 @@
   if(to->pyfunc)     { Py_DECREF(to->pyfunc); }
   to->name         = strdup(from->name);
   to->user_group   = strdup(from->user_group);
-  if(from->pyfunc)   { Py_INCREF(from->pyfunc); }
+  to->pyfunc       = from->pyfunc;
+  if(to->pyfunc)     { Py_INCREF(to->pyfunc); }
   to->func         = from->func;
   to->interrupts   = from->interrupts;
+  if(to->checks)     { deleteListWith(to->checks, deleteCmdCheck); }
+  to->checks       = listCopyWith(from->checks, cmdCheckCopy);
 }
 
 const char *cmdGetName(CMD_DATA *cmd) {
@@ -264,7 +281,11 @@
   return cmd_ok;
 }
 
-bool charTryCmd(CHAR_DATA *ch, CMD_DATA *cmd, char *arg) {
+bool cmdHasFunc(CMD_DATA *cmd) {
+  return (cmd->func != NULL || cmd->pyfunc != NULL);
+}
+
+int charTryCmd(CHAR_DATA *ch, CMD_DATA *cmd, char *arg) {
   // first, go through all of our checks
   if(!cmdTryChecks(ch, cmd))
     return FALSE;
@@ -281,9 +302,11 @@
       interrupt_action(ch, 1);
 #endif
     }
-    if(cmd->func)
+    if(cmd->func) {
       (cmd->func)(ch, cmd->name, arg);
-    else {
+      return TRUE;
+    }
+    else if(cmd->pyfunc) {
       PyObject *arglist = Py_BuildValue("Oss", charGetPyFormBorrowed(ch), 
 					cmd->name, arg);
       PyObject *retval  = PyEval_CallObject(cmd->pyfunc, arglist);
@@ -294,8 +317,11 @@
       // garbage collection
       Py_XDECREF(retval);
       Py_XDECREF(arglist);
+      return TRUE;
     }
-    return TRUE;
+    // command is null (but there might have been checks)
+    else
+      return -1;
   }
 }
 
